# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from majordomo_ai.models.data_store_scope import DataStoreScope
from majordomo_ai.models.model_profile_scope import ModelProfileScope
from typing import Optional, Set
from typing_extensions import Self

class AllowedProfiles(BaseModel):
    """
    This describes the list of permitted profiles and stores for the user on a workspace basis.
    """ # noqa: E501
    name: StrictStr = Field(description="Name of the workspace.")
    model_profiles: Optional[List[ModelProfileScope]] = Field(default=None, description="List of model profiles permitted for the user.")
    vectordb_profiles: Optional[List[StrictStr]] = Field(default=None, description="List of vectordb profiles permitted for the user.")
    monitor_profiles: Optional[List[StrictStr]] = Field(default=None, description="List of monitor profiles permitted for the user.")
    data_stores: Optional[List[DataStoreScope]] = Field(default=None, description="List of data stores permitted for the user.")
    query_pipelines: Optional[List[StrictStr]] = Field(default=None, description="List of data stores in each workspace that is created by the user.")
    __properties: ClassVar[List[str]] = ["name", "model_profiles", "vectordb_profiles", "monitor_profiles", "data_stores", "query_pipelines"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AllowedProfiles from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in model_profiles (list)
        _items = []
        if self.model_profiles:
            for _item_model_profiles in self.model_profiles:
                if _item_model_profiles:
                    _items.append(_item_model_profiles.to_dict())
            _dict['model_profiles'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in data_stores (list)
        _items = []
        if self.data_stores:
            for _item_data_stores in self.data_stores:
                if _item_data_stores:
                    _items.append(_item_data_stores.to_dict())
            _dict['data_stores'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AllowedProfiles from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "model_profiles": [ModelProfileScope.from_dict(_item) for _item in obj["model_profiles"]] if obj.get("model_profiles") is not None else None,
            "vectordb_profiles": obj.get("vectordb_profiles"),
            "monitor_profiles": obj.get("monitor_profiles"),
            "data_stores": [DataStoreScope.from_dict(_item) for _item in obj["data_stores"]] if obj.get("data_stores") is not None else None,
            "query_pipelines": obj.get("query_pipelines")
        })
        return _obj


