# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from majordomo_ai.models.app_profile_info import AppProfileInfo
from typing import Optional, Set
from typing_extensions import Self

class AppProfiles(BaseModel):
    """
    AppProfiles
    """ # noqa: E501
    app_profiles: Optional[List[AppProfileInfo]] = None
    shared_profiles: Optional[List[AppProfileInfo]] = None
    __properties: ClassVar[List[str]] = ["app_profiles", "shared_profiles"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AppProfiles from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in app_profiles (list)
        _items = []
        if self.app_profiles:
            for _item_app_profiles in self.app_profiles:
                if _item_app_profiles:
                    _items.append(_item_app_profiles.to_dict())
            _dict['app_profiles'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in shared_profiles (list)
        _items = []
        if self.shared_profiles:
            for _item_shared_profiles in self.shared_profiles:
                if _item_shared_profiles:
                    _items.append(_item_shared_profiles.to_dict())
            _dict['shared_profiles'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AppProfiles from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "app_profiles": [AppProfileInfo.from_dict(_item) for _item in obj["app_profiles"]] if obj.get("app_profiles") is not None else None,
            "shared_profiles": [AppProfileInfo.from_dict(_item) for _item in obj["shared_profiles"]] if obj.get("shared_profiles") is not None else None
        })
        return _obj


