# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from majordomo_ai.models.data_store_types import DataStoreTypes
from typing import Optional, Set
from typing_extensions import Self

class DataStore(BaseModel):
    """
    This is the data store specification that is used for creating and updating a data store. Data stores can be of different types including a vector database. Some parameters are mandatory based on the type of database chosen and it will be indicated along with the parameter.
    """ # noqa: E501
    workspace: StrictStr = Field(description="Workspace in which the data store is present.")
    name: StrictStr = Field(description="Name of the data store.")
    store_type: DataStoreTypes
    app_profile_name: StrictStr = Field(description="Name of the application profile.")
    contents: Optional[StrictStr] = Field(default=None, description="Description of the data store. This can be optionally included in queries.")
    instance_info: Optional[Dict[str, Any]] = Field(default=None, description="Information about the vector data store.")
    shared_users: Optional[List[StrictStr]] = Field(default=None, description="The list of users this profile is shared with.")
    __properties: ClassVar[List[str]] = ["workspace", "name", "store_type", "app_profile_name", "contents", "instance_info", "shared_users"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataStore from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataStore from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "workspace": obj.get("workspace"),
            "name": obj.get("name"),
            "store_type": obj.get("store_type"),
            "app_profile_name": obj.get("app_profile_name"),
            "contents": obj.get("contents"),
            "instance_info": obj.get("instance_info"),
            "shared_users": obj.get("shared_users")
        })
        return _obj


