# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from majordomo_ai.models.ingest_params import IngestParams
from majordomo_ai.models.ingest_types import IngestTypes
from typing import Optional, Set
from typing_extensions import Self

class DownloadAndParseFileStep(BaseModel):
    """
    Download and parse file step.
    """ # noqa: E501
    app_profile_name: StrictStr = Field(description="The name of the application profile to access the content.")
    input_filter: Dict[str, Any] = Field(description="Input information like file list.")
    ingest_params: Optional[IngestParams] = None
    ingest_type: IngestTypes
    __properties: ClassVar[List[str]] = ["app_profile_name", "input_filter", "ingest_params", "ingest_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DownloadAndParseFileStep from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of ingest_params
        if self.ingest_params:
            _dict['ingest_params'] = self.ingest_params.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DownloadAndParseFileStep from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "app_profile_name": obj.get("app_profile_name"),
            "input_filter": obj.get("input_filter"),
            "ingest_params": IngestParams.from_dict(obj["ingest_params"]) if obj.get("ingest_params") is not None else None,
            "ingest_type": obj.get("ingest_type")
        })
        return _obj


