# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from majordomo_ai.models.deployment_spec import DeploymentSpec
from majordomo_ai.models.model_spec import ModelSpec
from typing import Optional, Set
from typing_extensions import Self

class InferenceProfile(BaseModel):
    """
    This contains information specific to an inference.
    """ # noqa: E501
    name: StrictStr = Field(description="Name of the inference deployment.")
    workspace: StrictStr = Field(description="Workspace in which the data store is present.")
    model_spec: ModelSpec
    deployment_spec: DeploymentSpec
    tags: Optional[List[StrictStr]] = Field(default=None, description="Tags to describe the infra where it is running or what its purpose is.")
    __properties: ClassVar[List[str]] = ["name", "workspace", "model_spec", "deployment_spec", "tags"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of InferenceProfile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of model_spec
        if self.model_spec:
            _dict['model_spec'] = self.model_spec.to_dict()
        # override the default output from pydantic by calling `to_dict()` of deployment_spec
        if self.deployment_spec:
            _dict['deployment_spec'] = self.deployment_spec.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of InferenceProfile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "workspace": obj.get("workspace"),
            "model_spec": ModelSpec.from_dict(obj["model_spec"]) if obj.get("model_spec") is not None else None,
            "deployment_spec": DeploymentSpec.from_dict(obj["deployment_spec"]) if obj.get("deployment_spec") is not None else None,
            "tags": obj.get("tags")
        })
        return _obj


