# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from majordomo_ai.models.log_levels import LogLevels
from typing import Optional, Set
from typing_extensions import Self

class LogInfo(BaseModel):
    """
    The various logs that are generated filtered based on user, workspace and timeframes.
    """ # noqa: E501
    workspace: StrictStr = Field(description="Workspce in which the log was genereated.")
    user_name: StrictStr = Field(description="The user for which this log was generated.")
    log_level: LogLevels
    topic: StrictStr = Field(description="The topic of the log message.")
    timestamp: StrictInt = Field(description="The timestamp of the generated log message.")
    message: StrictStr = Field(description="The log message generated for the user.")
    __properties: ClassVar[List[str]] = ["workspace", "user_name", "log_level", "topic", "timestamp", "message"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LogInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LogInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "workspace": obj.get("workspace"),
            "user_name": obj.get("user_name"),
            "log_level": obj.get("log_level"),
            "topic": obj.get("topic"),
            "timestamp": obj.get("timestamp"),
            "message": obj.get("message")
        })
        return _obj


