# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from majordomo_ai.models.metadata import Metadata
from majordomo_ai.models.query_modes import QueryModes
from typing import Optional, Set
from typing_extensions import Self

class QueryParams(BaseModel):
    """
    A data store query request
    """ # noqa: E501
    top_k: Optional[StrictInt] = Field(default=2, description="The number of vector db matches to consider for llm context")
    temperature: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The temperature of the LLM processing, the higher the more creative the LLM is.")
    doc_metadata: Optional[List[Metadata]] = Field(default=None, description="Dictionary of metadata key/value pairs that are to be inserted into the vector  database along with the chunks. This is useful while retrieval to restrict the  relevant chunks. ")
    query_mode: Optional[QueryModes] = None
    debug_mode: Optional[StrictBool] = Field(default=False, description="Query results will include debug information.")
    __properties: ClassVar[List[str]] = ["top_k", "temperature", "doc_metadata", "query_mode", "debug_mode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QueryParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in doc_metadata (list)
        _items = []
        if self.doc_metadata:
            for _item_doc_metadata in self.doc_metadata:
                if _item_doc_metadata:
                    _items.append(_item_doc_metadata.to_dict())
            _dict['doc_metadata'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QueryParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "top_k": obj.get("top_k") if obj.get("top_k") is not None else 2,
            "temperature": obj.get("temperature"),
            "doc_metadata": [Metadata.from_dict(_item) for _item in obj["doc_metadata"]] if obj.get("doc_metadata") is not None else None,
            "query_mode": obj.get("query_mode"),
            "debug_mode": obj.get("debug_mode") if obj.get("debug_mode") is not None else False
        })
        return _obj


