# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from majordomo_ai.models.no_sql_response import NoSQLResponse
from majordomo_ai.models.sql_response import SQLResponse
from typing import Optional, Set
from typing_extensions import Self

class QueryResponse(BaseModel):
    """
    Query response
    """ # noqa: E501
    text_response: Optional[StrictStr] = Field(default=None, description="Response from LLM for the user query.")
    sql_response: Optional[SQLResponse] = None
    no_sql_response: Optional[NoSQLResponse] = None
    text_nodes: Optional[List[StrictStr]] = Field(default=None, description="Embedding nodes that are pertaining to the query.")
    metadata: Optional[Dict[str, StrictStr]] = None
    __properties: ClassVar[List[str]] = ["text_response", "sql_response", "no_sql_response", "text_nodes", "metadata"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QueryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of sql_response
        if self.sql_response:
            _dict['sql_response'] = self.sql_response.to_dict()
        # override the default output from pydantic by calling `to_dict()` of no_sql_response
        if self.no_sql_response:
            _dict['no_sql_response'] = self.no_sql_response.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QueryResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "text_response": obj.get("text_response"),
            "sql_response": SQLResponse.from_dict(obj["sql_response"]) if obj.get("sql_response") is not None else None,
            "no_sql_response": NoSQLResponse.from_dict(obj["no_sql_response"]) if obj.get("no_sql_response") is not None else None,
            "text_nodes": obj.get("text_nodes"),
            "metadata": obj.get("metadata")
        })
        return _obj


