# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class WorkerInfo(BaseModel):
    """
    Worker configuration and operation information.
    """ # noqa: E501
    name: StrictStr = Field(description="Name of the worker.")
    worker_id: StrictStr = Field(description="The unique identifier that is automatically assigned to the worker.")
    access_key: StrictStr = Field(description="The client secret that is used to authenticate the worker. This needs to be provided when a worker tries to join Majordomo director.")
    client_status: StrictBool = Field(description="Indicates whether the worker is currently connected to the director.")
    client_url: Optional[StrictStr] = Field(default=None, description="The registered endpoint for the worker.")
    chat_worker: Optional[StrictBool] = Field(default=None, description="The worker is used as a means to access a chat server.")
    created_at: StrictInt = Field(description="Timestamp of the worker creation.")
    last_update: StrictInt = Field(description="Timestamp of the last update to the worker.")
    __properties: ClassVar[List[str]] = ["name", "worker_id", "access_key", "client_status", "client_url", "chat_worker", "created_at", "last_update"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkerInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkerInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "worker_id": obj.get("worker_id"),
            "access_key": obj.get("access_key"),
            "client_status": obj.get("client_status"),
            "client_url": obj.get("client_url"),
            "chat_worker": obj.get("chat_worker"),
            "created_at": obj.get("created_at"),
            "last_update": obj.get("last_update")
        })
        return _obj


