# coding: utf-8

"""
    Majordomo AI

    This is a API specification for Majordomo AI

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from majordomo_ai.models.workflow_providers import WorkflowProviders
from majordomo_ai.models.workflow_step import WorkflowStep
from typing import Optional, Set
from typing_extensions import Self

class Workflow(BaseModel):
    """
    Workflow information.
    """ # noqa: E501
    workspace: StrictStr = Field(description="Workspace in which the workflow is triggered.")
    name: StrictStr = Field(description="The id that uniquely identifies this workflow.")
    workflow_type: StrictStr = Field(description="The type of workflow, custom types are allowed as long as it is  supported in the worker. ")
    workflow_provider: Optional[WorkflowProviders] = None
    contents: Optional[StrictStr] = Field(default=None, description="Describes the work done by the workflow.")
    steps: List[WorkflowStep] = Field(description="Workflow specific data.")
    shared_users: Optional[List[StrictStr]] = Field(default=None, description="The list of users this workflow is shared with.")
    __properties: ClassVar[List[str]] = ["workspace", "name", "workflow_type", "workflow_provider", "contents", "steps", "shared_users"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Workflow from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in steps (list)
        _items = []
        if self.steps:
            for _item_steps in self.steps:
                if _item_steps:
                    _items.append(_item_steps.to_dict())
            _dict['steps'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Workflow from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "workspace": obj.get("workspace"),
            "name": obj.get("name"),
            "workflow_type": obj.get("workflow_type"),
            "workflow_provider": obj.get("workflow_provider"),
            "contents": obj.get("contents"),
            "steps": [WorkflowStep.from_dict(_item) for _item in obj["steps"]] if obj.get("steps") is not None else None,
            "shared_users": obj.get("shared_users")
        })
        return _obj


